"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.getMultiValue = exports.multiOnChange = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _select = _interopRequireDefault(require("@data-driven-forms/common/select"));

var _fnToString = _interopRequireDefault(require("@data-driven-forms/common/utils/fn-to-string"));

var _Select = _interopRequireDefault(require("carbon-components-react/lib/components/Select/Select.js"));

var _MultiSelect = _interopRequireDefault(require("carbon-components-react/lib/components/MultiSelect/MultiSelect.js"));

var _SelectItem = _interopRequireDefault(require("carbon-components-react/lib/components/SelectItem/SelectItem.js"));

var _ComboBox = _interopRequireDefault(require("carbon-components-react/lib/components/ComboBox/ComboBox.js"));

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var multiOnChange = function multiOnChange(input, simpleValue) {
  return function (_ref) {
    var selectedItem = _ref.selectedItem,
        selectedItems = _ref.selectedItems;

    if (simpleValue) {
      return input.onChange((selectedItems === null || selectedItems === void 0 ? void 0 : selectedItems.map(function (_ref2) {
        var value = _ref2.value;
        return value;
      })) || selectedItem.value);
    } else {
      return input.onChange(selectedItems || selectedItem);
    }
  };
};

exports.multiOnChange = multiOnChange;

var getMultiValue = function getMultiValue(value, options) {
  return (Array.isArray(value) ? value : value ? [value] : []).map(function (item) {
    return (0, _typeof2["default"])(item) === 'object' ? item : options.find(function (_ref3) {
      var value = _ref3.value;
      return value === item;
    });
  });
};

exports.getMultiValue = getMultiValue;

var ClearedMultiSelectFilterable = function ClearedMultiSelectFilterable(_ref4) {
  var invalidText = _ref4.invalidText,
      hideSelectedOptions = _ref4.hideSelectedOptions,
      noOptionsMessage = _ref4.noOptionsMessage,
      onInputChange = _ref4.onInputChange,
      options = _ref4.options,
      isFetching = _ref4.isFetching,
      invalid = _ref4.invalid,
      isMulti = _ref4.isMulti,
      classNamePrefix = _ref4.classNamePrefix,
      closeMenuOnSelect = _ref4.closeMenuOnSelect,
      onChange = _ref4.onChange,
      originalOnChange = _ref4.originalOnChange,
      carbonLabel = _ref4.carbonLabel,
      placeholder = _ref4.placeholder,
      isDisabled = _ref4.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref4, ["invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "isMulti", "classNamePrefix", "closeMenuOnSelect", "onChange", "originalOnChange", "carbonLabel", "placeholder", "isDisabled"]);
  return /*#__PURE__*/_react["default"].createElement(_MultiSelect["default"].Filterable, (0, _extends2["default"])({
    disabled: isDisabled
  }, rest, {
    placeholder: carbonLabel || placeholder,
    onChange: originalOnChange,
    titleText: rest.labelText,
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    items: options,
    initialSelectedItems: getMultiValue(rest.value, options)
  }));
};

ClearedMultiSelectFilterable.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool
};

var ClearedMultiSelect = function ClearedMultiSelect(_ref5) {
  var invalidText = _ref5.invalidText,
      hideSelectedOptions = _ref5.hideSelectedOptions,
      noOptionsMessage = _ref5.noOptionsMessage,
      onInputChange = _ref5.onInputChange,
      options = _ref5.options,
      isFetching = _ref5.isFetching,
      invalid = _ref5.invalid,
      isMulti = _ref5.isMulti,
      classNamePrefix = _ref5.classNamePrefix,
      closeMenuOnSelect = _ref5.closeMenuOnSelect,
      onChange = _ref5.onChange,
      originalOnChange = _ref5.originalOnChange,
      carbonLabel = _ref5.carbonLabel,
      placeholder = _ref5.placeholder,
      isDisabled = _ref5.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref5, ["invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "isMulti", "classNamePrefix", "closeMenuOnSelect", "onChange", "originalOnChange", "carbonLabel", "placeholder", "isDisabled"]);
  return /*#__PURE__*/_react["default"].createElement(_MultiSelect["default"], (0, _extends2["default"])({
    disabled: isDisabled
  }, rest, {
    label: carbonLabel || placeholder,
    onChange: originalOnChange,
    titleText: rest.labelText,
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    items: options,
    initialSelectedItems: getMultiValue(rest.value, options)
  }));
};

ClearedMultiSelect.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool
};

var getSelectValue = function getSelectValue(value, isMulti) {
  return isMulti ? value : Array.isArray(value) ? value[0] : value;
};

var ClearedSelect = function ClearedSelect(_ref6) {
  var isSearchable = _ref6.isSearchable,
      isClearable = _ref6.isClearable,
      isDisabled = _ref6.isDisabled,
      isMulti = _ref6.isMulti,
      invalidText = _ref6.invalidText,
      hideSelectedOptions = _ref6.hideSelectedOptions,
      noOptionsMessage = _ref6.noOptionsMessage,
      onInputChange = _ref6.onInputChange,
      options = _ref6.options,
      isFetching = _ref6.isFetching,
      invalid = _ref6.invalid,
      classNamePrefix = _ref6.classNamePrefix,
      closeMenuOnSelect = _ref6.closeMenuOnSelect,
      originalOnChange = _ref6.originalOnChange,
      placeholder = _ref6.placeholder,
      value = _ref6.value,
      rest = (0, _objectWithoutProperties2["default"])(_ref6, ["isSearchable", "isClearable", "isDisabled", "isMulti", "invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "classNamePrefix", "closeMenuOnSelect", "originalOnChange", "placeholder", "value"]);
  return /*#__PURE__*/_react["default"].createElement(_Select["default"], (0, _extends2["default"])({
    value: getSelectValue(value, isMulti),
    disabled: isFetching
  }, rest, {
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText
  }), isFetching && /*#__PURE__*/_react["default"].createElement(_SelectItem["default"], {
    text: placeholder,
    value: ''
  }), options.map(function (option, index) {
    return /*#__PURE__*/_react["default"].createElement(_SelectItem["default"], (0, _extends2["default"])({
      key: option.value || index,
      text: option.label
    }, option));
  }));
};

ClearedSelect.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  isSearchable: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  value: _propTypes["default"].any
};

var getComboInitialValue = function getComboInitialValue(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var result = Array.isArray(value) ? value[0] : value;
  return (0, _typeof2["default"])(result) === 'object' ? result : options.find(function (_ref7) {
    var value = _ref7.value;
    return value === result;
  }) || result;
};
/**
 * Combobox cannot be multi value
 */


var ClearedSelectSearchable = function ClearedSelectSearchable(_ref8) {
  var isSearchable = _ref8.isSearchable,
      isClearable = _ref8.isClearable,
      isDisabled = _ref8.isDisabled,
      isMulti = _ref8.isMulti,
      invalidText = _ref8.invalidText,
      hideSelectedOptions = _ref8.hideSelectedOptions,
      noOptionsMessage = _ref8.noOptionsMessage,
      onInputChange = _ref8.onInputChange,
      _ref8$options = _ref8.options,
      options = _ref8$options === void 0 ? [] : _ref8$options,
      isFetching = _ref8.isFetching,
      invalid = _ref8.invalid,
      classNamePrefix = _ref8.classNamePrefix,
      closeMenuOnSelect = _ref8.closeMenuOnSelect,
      originalOnChange = _ref8.originalOnChange,
      placeholder = _ref8.placeholder,
      labelText = _ref8.labelText,
      rest = (0, _objectWithoutProperties2["default"])(_ref8, ["isSearchable", "isClearable", "isDisabled", "isMulti", "invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "classNamePrefix", "closeMenuOnSelect", "originalOnChange", "placeholder", "labelText"]);
  return /*#__PURE__*/_react["default"].createElement(_ComboBox["default"], (0, _extends2["default"])({
    disabled: isFetching
  }, rest, {
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    initialSelectedItem: getComboInitialValue(rest.value, options),
    items: options,
    placeholder: placeholder,
    titleText: labelText,
    onChange: originalOnChange
  }));
};

ClearedSelectSearchable.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  isSearchable: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  labelText: _propTypes["default"].string
};

var Select = function Select(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      isMulti = _useFieldApi.isMulti,
      isSearchable = _useFieldApi.isSearchable,
      isClearable = _useFieldApi.isClearable,
      loadOptions = _useFieldApi.loadOptions,
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["isMulti", "isSearchable", "isClearable", "loadOptions", "input", "meta", "validateOnMount", "helperText"]);

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      loadOptionsChangeCounter = _useState2[0],
      setCounter = _useState2[1];

  var loadOptionsStr = (0, _fnToString["default"])(loadOptions);
  (0, _react.useEffect)(function () {
    setCounter(loadOptionsChangeCounter + 1); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [loadOptionsStr]);
  var isSearchClear = isSearchable || isClearable;
  var Component = isMulti && isSearchClear ? ClearedMultiSelectFilterable : isMulti ? ClearedMultiSelect : isSearchClear ? ClearedSelectSearchable : ClearedSelect;
  var invalidText = (meta.touched || validateOnMount) && (meta.error || meta.submitError) || '';
  var text = (meta.touched || validateOnMount) && meta.warning || helperText;
  return /*#__PURE__*/_react["default"].createElement(_select["default"], (0, _extends2["default"])({
    SelectComponent: Component,
    simpleValue: false
  }, rest, input, {
    isMulti: isMulti,
    loadOptions: loadOptions,
    invalidText: invalidText,
    loadOptionsChangeCounter: loadOptionsChangeCounter,
    originalOnChange: multiOnChange(input, rest.simpleValue),
    helperText: text
  }));
};

Select.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    label: _propTypes["default"].node
  }))
};
Select.defaultProps = {
  loadingMessage: 'Loading...'
};
var _default = Select;
exports["default"] = _default;